routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check()) return redirect(route('home'));
    else return view('Auth/login');
});

Route::group(['middleware' => ['auth']], function (){
    Route::get('/user/profile', 'UserController@edit')->name('user_profile');
    Route::patch('/user/profile', 'UserController@update')->name('user_profile_edit');
    Route::get('users', 'UserController@index')->name('users');
    Route::get('users/{id}/profile', 'UserController@show')->name('user_info');
    Route::get('search', 'UserController@autocomplete');

    Route::resource('post', 'PostController');
    Route::get('/home', 'PostController@allPosts')->name('home');
    Route::get('/user/{id}/posts', 'PostController@userFriendPosts')->name('userFriendPosts');
    Route::resource('like', 'LikeController');
    Route::resource('comment', 'CommentController');
    Route::resource('follow', 'FollowController');

});

Auth::routes();

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    //
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class);
    }

    public function likes()
    {
        return $this->hasMany(Like::class);
    }

}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Like;
use App\Post;
use App\User;
use App\Follower;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $posts = Post::where('user_id','=', auth()->id())->paginate(3);

        $active_profile = 'primary';
        return view('post.index', compact('posts', 'active_profile'));
    }

    public function allPosts()
    {
        //
        $posts=Post::withCount('likes')
            ->whereIn('user_id', auth()->user()->following()->where('accepted', '=', 1)
                ->pluck('to_user_id')
            )->paginate(3);
        $active_home = 'primary';
        return view('home', compact('posts', 'active_home'));
    }

    public function userFriendPosts($id)
    {
        //
        //$is_follower=Follower::where(['from_user_id'=> auth()->id(), 'to_user_id'=> $id, 'accepted'=> 1])->get();

        if (policy(Post::class)->userFriendPosts(auth()->user(), $id)){
            $posts = Post::withCount('likes')->where(['user_id'=>$id])->paginate(3);
            $friend_name=null;
            if (count($posts))
                $friend_name = $posts[0]->user->first_name .' '. $posts[0]->user->last_name;
            return view('home', compact('posts','friend_name'));
        }

        return redirect('home');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return view('post.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // save the data
        $img_name = '';
        if ($request->hasFile('filename')){
            $file = $request->file('filename');
            $img_name = Auth::id().'-'.time().'-'.$file->getClientOriginalName();
            $file->move(public_path().'/images/', $img_name);
        }
        $post = new Post();
        $post->body = $request->get('body');
        $post->user_id= Auth::id();
        $post->image_path=$img_name;
        $post->save();
        return redirect(route('post.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
        $post=Post::with('user')->find($id);
        $user = auth()->user();
        if ($user->can('show', $post)){
            $likes = Like::where('post_id', $id)->count();
            $user_like = Like::where(['user_id' => auth()->id(), 'post_id' => $id])->get();
            $post_comments = Comment::where('post_id', $id)->get();
            return view('post.show', compact('post', 'likes', 'user_like', 'post_comments'));
        }
        else
            return redirect('not_found');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $post=Post::find($id);
        if (auth()->user()->can('edit', $post))
            return view('post.edit', compact('post'));
        else
            return redirect('not_found');

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $post=Post::find($id);
        if (auth()->user()->can('update', $post)){
            $post->body=$request->get('body');
            $post->save();
            return $this->show($id);
        }
        else
            return redirect('not_found');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $post=Post::find($id);
        if (auth()->user()->can('delete', $post)){
            $post->delete();
            return redirect(route('post.index'));
        }
        else
            return redirect('not_found');
    }
}

resources/views/post/create.blade.php
@extends('layouts.app')

@section('content')
<div class="album py-5 bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-2"></div>
            <div class="col-md-8" style="direction:  rtl;text-align: right;">
                <form method="post" action="{{ url('post') }}" enctype="multipart/form-data">
                    @csrf
                    <div class="row">
                        <div class="col-md-12 mb-6">
                            <label for="file_label">قم برفع صورة</label>
                            <input type="file" class="form-control" id="file_label" name="filename" required>
                        </div>
                        <div class="col-md-12 mb-6">
                            <label for="post_body">حول الصورة</label>
                            <textarea class="form-control" id="post_body" placeholder="" name="body" required></textarea>
                            <div class="invalid-feedback">
                                قل شيئاً عن الصورة
                            </div>
                        </div>
                    </div>
                    <div class="row" style="margin-top:  5%;">
                        <div class="col-md-12 mb-6">
                            <button class="btn btn-primary btn-lg btn-block" type="submit">نشر الصورة</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/post/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="album py-5 bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-2"></div>
            <div class="col-md-8">
                <div class="card mb-8 box-shadow">
                    <img class="card-img-top" src="{{ asset('images/'.$post->image_path) }}" alt="Card image cap">
                    <div class="card-body" style="direction: rtl;">
                        <form method="POST" action="{{ route('post.update', $post->id) }}">
                            @csrf
                            @method('PATCH')
                            <input type="hidden" name="image_path" value="{{ $post->image_path }}">
                            <textarea class="form-control" id="post_body" placeholder="" name="body" required>{{ $post->body }}</textarea>
                            <div class="d-flex justify-content-between align-items-center">
                                <div class="btn-group" style="margin-top: 5px;">
                                    <button type="submit" class="btn btn-sm btn-outline-secondary">حفظ التعديلات</button>
                                </div>
                                <small class="text-muted"></small>
                            </div>
                            <input name="_method" type="hidden" value="PATCH">
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/post/index.blade.php
@extends('layouts.app')

@section('content')
<div class="album py-5 bg-light">
    <div class="container">

        <div class="row">
            <!-- foreach post -->
            @forelse($posts as $post)
            <div class="col-md-4">
                <div class="card mb-4 box-shadow">
                    <!-- post image -->
                    <img class="card-img-top" src="{{ asset('images/'.$post->image_path) }}" alt="Card image cap" style="height: 250px">
                    <div class="card-body" style="height:  116px;">
                        <!-- post body -->
                        <p class="card-text" style="text-align: right;direction:  rtl;">{{ Str::limit($post->body, 80)  }}</p>
                        <br>
                    </div>
                    <div class="card-footer">
                        <div class="d-flex justify-content-between align-items-center">
                            <!-- post actions -->
                            <form action="{{ route('post.destroy', $post->id) }}" method="post">
                                <div class="btn-group">
                                    <a class="btn btn-sm btn-outline-secondary" href="{{ route('post.show', $post->id) }}">عرض</a>
                                    <a class="btn btn-sm btn-outline-secondary" href="{{ route('post.edit', $post->id) }}">تعديل</a>
                                    @method('DELETE')
                                    @csrf
                                    <button class="btn btn-sm btn-outline-secondary">حذف</button>
                                </div>
                            </form>
                            <!-- post date -->
                            <small class="text-muted"></small>
                        </div>
                    </div>
                </div>
            </div>
            <!-- foreach post end -->
            @empty
                <a href="{{ route('post.create') }}">Add your first post</a>

            @endforelse

            @isset($posts)
                {{ $posts->links('pagination::bootstrap-4') }}
                @endisset
        </div>
        <!-- Paginations -->
    </div>
</div>
@endsection

resources/views/post/show.blade.php
@extends('layouts.app')
@section('content')
<div class="album py-5 bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-2"></div>
            <div class="col-md-8">
                <div class="card mb-8 box-shadow">
                    <div class="card-header" style="background-color:  white;">
                        <div class="media text-muted pt-3" style="direction:  rtl;">
                            <img src="{{ asset('images/avatar/'.$post->user->avatar) }}" alt="" class="col-sm-2 rounded" style="margin-right: -3%; width: 50px;height: 50px;">
                            <div class="media-body pb-3 mb-0" style="text-align: right;direction:  rtl;" >
                                <p class="card-text" style="text-align: right;direction:  rtl;">{{ $post->user->name }}</p>
                            </div>
                        </div>
                        @can('delete', $post)
                            <form action="{{ route('post.destroy', $post->id) }}" method="POST">
                                @method('DELETE')
                                @csrf
                                <button class="btn btn-sm btn-outline-secondary" type="submit">حذف</button>
                            </form>
                        @endcan
                    </div>
                    <img class="card-img-top" src="{{ asset('images/'.$post->image_path) }}" alt="Card image cap">
                    <div class="card-body">
                        <p class="card-text" style="text-align: right;direction:  rtl;">{{ $post->body }}</p>
                        <div class="d-flex justify-content-between align-items-center">

                            <div class="row">
                                <div class="btn-group" style="margin-top:  4px;">
                                    <button class="btn btn-sm btn-outline-secondary" type="button" >
                                        <i class="fa fa-heart" style="margin-right:  10%;"></i>
                                        <label id="count_id">{{$likes}}</label>
                                    </button>
                                    <button class="btn btn-sm btn-outline-secondary" id="btn_value_id" onclick="like_action()"> أعجبني </button>
                                </div>
                            </div>

                            <small class="text-muted">{{ $post->created_at }}</small>
                        </div>
                    </div>
                    <div class="card-footer" style="direction:  rtl;text-align:  right;">
                        <div class="media text-muted pt-3">
                            <img src="{{ asset('images/avatar/'.$post->user->avatar) }}" alt="" class="col-sm-2 rounded" style="margin-top:  1%;margin-right: -3%; width: 50px;height: 50px;">
                            <div class="media-body pb-3 mb-0 small lh-125 border-bottom border-gray" >
                                <div class="d-flex justify-content-between align-items-center w-100">
                                    <strong class="text-gray-dark"></strong>
                                </div>
                                <form method="POST" action="{{ route('comment.store') }}">
                                    @csrf
                                    <input type="hidden" name="post_id" value="{{ $post->id }}">
                                    <div class="row">
                                        <div class="col-md-10">
                                            <input type="text" name="comment" class="form-control" placeholder="أضف تعليقاً" style="width:  100%;">
                                        </div>
                                        <div class="col-md-2" style="margin-top:  4px;">
                                            <input type="submit" class="btn btn-sm btn-outline-secondary" name="send" value="إضافة التعليق">
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>

                    @foreach($post_comments as $comment)
                    <div class="media text-muted pt-3">
                        <img src="{{ asset('images/avatar/'.$comment->user->avatar) }}" alt="" class="col-sm-2 rounded" style="margin-top:  1%;margin-right: -3%; width: 50px;height: 50px;">
                        <div class="media-body pb-3 mb-0 small lh-125 border-bottom border-gray" >
                            <div class="d-flex justify-content-between align-items-center w-100">
                                <strong class="text-gray-dark">{{$comment->user->name}}</strong><br>
                                @if($comment->user_id == auth()->id())
                                    <form method="POST" action="{{ route('comment.destroy', $comment->id) }}">
                                        @method('DELETE')
                                        @csrf
                                        <input type="submit" class="btn btn-outline-danger" value="delete">
                                    </form>
                                @endif
                            </div>
                            <span class="d-block">{{ $comment->comment }}</span>
                        </div>
                    </div>
                    @endforeach

                </div>
            </div>
        </div>
    </div>
</div>

<script src="{{ asset('assets/js/jquery-3.3.1.min.js') }}"></script>
<script>
    var like = "اعجبني";
    var unlike = "الغاء الاعجاب";
    var token = "{{ csrf_token() }}";
    var post_id = "{{ $post->id }}";
    var like_id = 0;
    @if($user_like->count()){
        like_id = "{{ $user_like[0]->id }}";
        $('#btn_value_id').html(unlike);
    }
    @endif

    function like_action() {
        if(like_id ==0){
            $.ajax({
                type: "POST",
                url: "{{ route('like.store') }}",
                data: {post_id: post_id, _token: token},
                success: function (msg) {
                    $('#count_id').html(msg.count);
                    $('#btn_value_id').html(unlike);
                    like_id = msg.id;
                }
            })
        }
        else{
            $.ajax({
                type: "POST",
                url: "{{ url('like') }}/"+post_id,
                data: {_token: token, _method:"DELETE"},
                success: function (msg) {
                    $('#count_id').html(msg.count);
                    $('#btn_value_id').html(like);
                    like_id = 0;
                }
            })
        }
    }

</script>
@endsection